sidebarNodes={"extras":[{"group":"","headers":[{"anchor":"modules","id":"Modules"}],"id":"api-reference","title":"API Reference"},{"group":"Examples","headers":[{"anchor":"official-producers","id":"Official Producers"},{"anchor":"non-official-off-broadway-producers","id":"Non-official (Off-Broadway) Producers"}],"id":"introduction","title":"Introduction"},{"group":"Examples","headers":[{"anchor":"getting-started","id":"Getting Started"},{"anchor":"create-a-sqs-queue","id":"Create a SQS queue"},{"anchor":"configure-the-project","id":"Configure the project"},{"anchor":"define-the-pipeline-configuration","id":"Define the pipeline configuration"},{"anchor":"implement-broadway-callbacks","id":"Implement Broadway callbacks"},{"anchor":"run-the-broadway-pipeline","id":"Run the Broadway pipeline"},{"anchor":"tuning-the-configuration","id":"Tuning the configuration"}],"id":"amazon-sqs","title":"Amazon SQS"},{"group":"Examples","headers":[{"anchor":"getting-started","id":"Getting Started"},{"anchor":"create-a-stream-of-records-or-use-an-existing-one","id":"Create a stream of records (or use an existing one)"},{"anchor":"configure-your-elixir-project-to-use-broadway","id":"Configure your Elixir project to use Broadway"},{"anchor":"define-the-pipeline-configuration","id":"Define the pipeline configuration"},{"anchor":"implement-broadway-callbacks","id":"Implement Broadway callbacks"},{"anchor":"run-the-broadway-pipeline","id":"Run the Broadway pipeline"},{"anchor":"tuning-the-configuration","id":"Tuning the configuration"},{"anchor":"handling-failed-messages","id":"Handling failed messages"}],"id":"apache-kafka","title":"Apache Kafka"},{"group":"Examples","headers":[{"anchor":"getting-started","id":"Getting Started"},{"anchor":"setup-cloud-pub-sub-project","id":"Setup Cloud Pub/Sub project"},{"anchor":"configure-the-project","id":"Configure the project"},{"anchor":"define-the-pipeline-configuration","id":"Define the pipeline configuration"},{"anchor":"implement-broadway-callbacks","id":"Implement Broadway callbacks"},{"anchor":"run-the-broadway-pipeline","id":"Run the Broadway pipeline"},{"anchor":"tuning-the-configuration","id":"Tuning the configuration"}],"id":"google-cloud-pubsub","title":"Google Cloud Pub/Sub"},{"group":"Examples","headers":[{"anchor":"getting-started","id":"Getting Started"},{"anchor":"create-a-queue","id":"Create a queue"},{"anchor":"configure-the-project","id":"Configure the project"},{"anchor":"define-the-pipeline-configuration","id":"Define the pipeline configuration"},{"anchor":"implement-broadway-callbacks","id":"Implement Broadway callbacks"},{"anchor":"run-the-broadway-pipeline","id":"Run the Broadway pipeline"},{"anchor":"tuning-the-configuration","id":"Tuning the configuration"}],"id":"rabbitmq","title":"RabbitMQ"},{"group":"Examples","headers":[{"anchor":"example","id":"Example"}],"id":"custom-producers","title":"Custom Producers"},{"group":"Internals","headers":[{"anchor":"the-pipeline-model","id":"The pipeline model"},{"anchor":"internal-stages","id":"Internal stages"},{"anchor":"the-supervision-tree","id":"The supervision tree"},{"anchor":"graceful-shutdowns","id":"Graceful shutdowns"}],"id":"architecture","title":"Architecture"}],"modules":[{"group":"","id":"Broadway","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:name/0","id":"name/0","title":"name()"},{"anchor":"t:on_start/0","id":"on_start/0","title":"on_start()"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"anchor":"c:handle_batch/4","id":"handle_batch/4","title":"handle_batch(batcher, messages, batch_info, context)"},{"anchor":"c:handle_failed/2","id":"handle_failed/2","title":"handle_failed(messages, context)"},{"anchor":"c:handle_message/3","id":"handle_message/3","title":"handle_message(processor, message, context)"},{"anchor":"c:prepare_messages/2","id":"prepare_messages/2","title":"prepare_messages(messages, context)"},{"anchor":"c:process_name/2","id":"process_name/2","title":"process_name(broadway_name, base_name)"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"all_running/0","id":"all_running/0","title":"all_running()"},{"anchor":"get_rate_limiting/1","id":"get_rate_limiting/1","title":"get_rate_limiting(broadway)"},{"anchor":"producer_names/1","id":"producer_names/1","title":"producer_names(broadway)"},{"anchor":"push_messages/2","id":"push_messages/2","title":"push_messages(broadway, messages)"},{"anchor":"start_link/2","id":"start_link/2","title":"start_link(module, opts)"},{"anchor":"stop/3","id":"stop/3","title":"stop(broadway, reason \\\\ :normal, timeout \\\\ :infinity)"},{"anchor":"test_batch/3","id":"test_batch/3","title":"test_batch(broadway, batch_data, opts \\\\ [])"},{"anchor":"test_message/3","id":"test_message/3","title":"test_message(broadway, data, opts \\\\ [])"},{"anchor":"topology/1","id":"topology/1","title":"topology(broadway)"},{"anchor":"update_rate_limiting/2","id":"update_rate_limiting/2","title":"update_rate_limiting(broadway, opts)"}]}],"sections":[{"anchor":"module-built-in-features","id":"Built-in features"},{"anchor":"module-the-broadway-behaviour","id":"The Broadway behaviour"},{"anchor":"module-batching","id":"Batching"},{"anchor":"module-acknowledgements-and-failures","id":"Acknowledgements and failures"},{"anchor":"module-producer-concurrency","id":"Producer concurrency"},{"anchor":"module-batcher-concurrency","id":"Batcher concurrency"},{"anchor":"module-testing","id":"Testing"},{"anchor":"module-ordering-and-partitioning","id":"Ordering and partitioning"},{"anchor":"module-telemetry","id":"Telemetry"}],"title":"Broadway"},{"group":"","id":"Broadway.BatchInfo","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0","title":"t()"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"__struct__/0","id":"%Broadway.BatchInfo{}","title":"%Broadway.BatchInfo{}"}]}],"sections":[],"title":"Broadway.BatchInfo"},{"group":"","id":"Broadway.Message","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:acknowledger/0","id":"acknowledger/0","title":"acknowledger()"},{"anchor":"t:t/0","id":"t/0","title":"t()"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"ack_immediately/1","id":"ack_immediately/1","title":"ack_immediately(message_or_messages)"},{"anchor":"configure_ack/2","id":"configure_ack/2","title":"configure_ack(message, options)"},{"anchor":"failed/2","id":"failed/2","title":"failed(message, reason)"},{"anchor":"put_batch_key/2","id":"put_batch_key/2","title":"put_batch_key(message, batch_key)"},{"anchor":"put_batch_mode/2","id":"put_batch_mode/2","title":"put_batch_mode(message, mode)"},{"anchor":"put_batcher/2","id":"put_batcher/2","title":"put_batcher(message, batcher)"},{"anchor":"put_data/2","id":"put_data/2","title":"put_data(message, data)"},{"anchor":"update_data/2","id":"update_data/2","title":"update_data(message, fun)"}]}],"sections":[],"title":"Broadway.Message"},{"group":"Acknowledgement","id":"Broadway.Acknowledger","nodeGroups":[{"key":"callbacks","name":"Callbacks","nodes":[{"anchor":"c:ack/3","id":"ack/3","title":"ack(ack_ref, successful, failed)"},{"anchor":"c:configure/3","id":"configure/3","title":"configure(ack_ref, ack_data, options)"}]}],"sections":[],"title":"Broadway.Acknowledger"},{"group":"Acknowledgement","id":"Broadway.CallerAcknowledger","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"init/2","id":"init/2","title":"init(pid_and_ref, ignored_term)"}]}],"sections":[],"title":"Broadway.CallerAcknowledger"},{"group":"Acknowledgement","id":"Broadway.NoopAcknowledger","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"init/0","id":"init/0","title":"init()"}]}],"sections":[],"title":"Broadway.NoopAcknowledger"},{"group":"Producers","id":"Broadway.DummyProducer","sections":[],"title":"Broadway.DummyProducer"},{"group":"Producers","id":"Broadway.Producer","nodeGroups":[{"key":"callbacks","name":"Callbacks","nodes":[{"anchor":"c:prepare_for_draining/1","id":"prepare_for_draining/1","title":"prepare_for_draining(state)"},{"anchor":"c:prepare_for_start/2","id":"prepare_for_start/2","title":"prepare_for_start(module, options)"}]}],"sections":[{"anchor":"module-injected-broadway-configuration","id":"Injected Broadway configuration"},{"anchor":"module-optional-callbacks","id":"Optional callbacks"},{"anchor":"module-producing-broadway-messages","id":"Producing Broadway messages"}],"title":"Broadway.Producer"}],"tasks":[]}